<template>
  <div id="transactions">
    <div class="title-page">
        <div class="title">{{ $t('deposit.transaction_detail.title') }}</div>
        <div v-if="transactions.length > 0" class="export"><a :href="exportUrl">{{ $t('deposit.transaction_detail.description') }}<span class="iconmo iconmo-export"></span></a></div>
    </div>
    <template v-if="transactions.length > 0">
      <div class="wrapper-table">
        <table class="transactions">
          <thead>
            <tr>
              <th class="date">{{ $t('deposit.transaction_detail.date') }}</th>
              <th class="coin">{{ $t('deposit.transaction_detail.coin') }}</th>
              <th class="amount">{{ $t('deposit.transaction_detail.amount') }}</th>
              <th class="status">{{ $t('deposit.transaction_detail.status') }}</th>
              <th class="information">{{ $t('deposit.transaction_detail.information') }}</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="transaction in transactions">
              <td class="date">{{ formatDate(transaction) }}</td>
              <td class="coin">{{ transaction.currency }}</td>
              <td class="amount">{{ transaction.amount | formatCurrencyAmount(transaction.currency, '0') }}</td>
              <td class="status" :class="transaction.status">{{ transaction | transactionStatus }}</td>
              <information :transaction="transaction"></information>
            </tr>
          </tbody>
        </table>
      </div>
    </template>
    <template v-else>
      <div class="wrapper-table">
        <table class="transactions">
          <thead>
            <tr>
              <th class="date">{{ $t('deposit.transaction_detail.date') }}</th>
              <th class="coin">{{ $t('deposit.transaction_detail.coin') }}</th>
              <th class="amount">{{ $t('deposit.transaction_detail.amount') }}</th>
              <th class="status">{{ $t('deposit.transaction_detail.status') }}</th>
              <th class="information">{{ $t('deposit.transaction_detail.information') }}</th>
            </tr>
          </thead>
        </table>
      </div>
      <div class="not-found">
        <span class="iconmo-not-found not-found__icon"></span>
        <span class="not-found__text">{{ $t('deposit.not_found_text') }}</span>
      </div>
    </template>
  </div>
</template>
<script>
import { mapState } from 'vuex';
import moment from 'moment';

import rf from '../../common/requests/RequestFactory';
import Information from '../components/transactions/Information.vue';

export default {
  data () {
    return {
      transactions: [],
      exportUrl: '',
      type: 'deposit',
    };
  },
  components: {
    Information,
  },
  computed: {
    ...mapState([
      'user',
    ]),
  },
  methods: {
    async getDepositTransactions () {
      if (this.user) {
        const res = await rf.getRequest('WalletRequest').getTransactions({type: this.type});
        this.transactions = [...res.data];
      }
    },
    formatDate (transaction) {
      return moment(transaction.created_at).format('YYYY-MM-DD HH:mm:ss');
    },
    getTimzoneOffset() {
      let d = new Date();
      return d.getTimezoneOffset();
    },
  },
  watch: {
    user () {
      this.getDepositTransactions();
    },
  },
  created () {
    this.$on('TransactionUpdated', () => {
      this.getDepositTransactions();
    });
    this.getDepositTransactions();
    this.exportUrl = `${this.$baseUrl}/export/wallet/transactions?type=deposit&timezone_offset=${this.getTimzoneOffset()}`;
  },
};
</script>
<style lang="scss" scoped>
@import '../../../sass/app.scss';
  #transactions {
    width: 1130px;
    margin: 56px auto 0;
    font-family: 'Roboto';
    min-height: calc(100vh - 165px);
    .title-page {
      font-size: 0;

      .title {
        width: 60%;
        display: inline-block;
        font-size: 30px;
        font-weight: bold;
        color: #1c1c1c;
      }

      .export {
        width: 40%;
        display: inline-block;
        text-align: right;
        font-size: 14px;
        font-weight: bold;
        a {
          font-family: 'Roboto';
          color: #1c1c1c;
          text-decoration: none;
          .iconmo {
            color: #fa7300;
            font-size: 12px;
          }
        }
      }
    }
    .wrapper-table {
      width: 100%;
      position: relative;
      margin-top: 17px;
      padding-bottom: 50px;

      &:before {
        content: '';
        display: block;
        position: absolute;
        top: 0;
        left: 0;
        height: 50px;
        width: 100%;
        border-radius: 30px;
        background-color: #efefef;
        z-index: -1;
      }

      table.transactions {
        width: 100%;
        tr {
          height: 50px;
          td, th {
            font-family: 'Roboto';
            color: #1c1c1c;
            font-size: 14px;
            font-weight: normal;
            font-style: normal;
            font-stretch: normal;
            line-height: 3.57;
            letter-spacing: normal;
          }
          .status {
            width: 150px;
            text-transform: capitalize;
            &.waiting {
              color: #4a90e2;
            }
            &.confirming {
              color: #4caf50;
            }
            &.succeeded {
              color: #fa7300;
            }
            &.failed {
              color: #d0021b;
            }
          }
          .coin {
            width: 100px;
            text-transform: uppercase;
          }
          .amount {
            width: 160px;
          }
          .date {
            width: 180px;
            padding-left: 30px;
          }
        }
        thead {
          tr {
            th {
              font-weight: bold;
              text-transform: capitalize !important;
            }
          }
        }
        tbody {
          tr {
            border-bottom: 1px solid #e0e0e0;
          }
        }
      }
    }

    .not-found {
      margin-top: 3px;
      text-align: center;
      .not-found__icon {
        padding: 25px;
        background-color: $bg_thin_gray;
        border-radius: 50%;
        font-size: 110px;
        display: inline-block;
        margin-bottom: 15px;
      }

      .not-found__text {
        display: block;
        font-size: 20px;
        color: $thin_gray;
      }
    }
  }

  @media screen and (max-width: 1200px) {
    #transactions {
      width: 100%;
      padding: 56px 20px 80px;
      margin-top: 0;
      .title {
        padding-top: 0;
      }
    }
  }
</style>
